/* eslint-disable no-useless-escape */


const _ = require('lodash');

/**
 * Created by noam
 */

class Vars {

    constructor(value) {
        this.value = value;
        this.variableKeys = this.findVariables(value);
    }

    findVariables(value) {
        if (!value) {
            return [];
        }
        const varRegex = /\$\{\{([^\$\{\}]+)\}\}/gi;
        let matches;
        const keys = [];

        // eslint-disable-next-line no-cond-assign
        while (matches = varRegex.exec(value)) {
            keys.push(matches[1]);
        }

        return keys;
    }

    valueContainsVariables() {
        return this.variableKeys && (this.variableKeys.length !== 0);
    }

    getVariableKeys() {
        return this.variableKeys;
    }

    replaceVariables(dictionary) {
        let resolvedValue = this.value;
        if (!resolvedValue) {
            return resolvedValue;
        }
        const variableKeys = this.getVariableKeys();
        if (!variableKeys || variableKeys.length < 1) {
            return resolvedValue;
        }
        if (!dictionary) {
            return resolvedValue;
        }
        variableKeys.forEach((variableKey) => {
            let value = dictionary[variableKey];
            if (!value && variableKey.includes('.')) {
                value = _.get(dictionary, variableKey.split('.'));
            }
            if (value && value.toString() !== '[object Object]') {
                resolvedValue = resolvedValue.replace(`\$\{\{${variableKey}\}\}`, value);
            }
        });
        return resolvedValue;
    }
}

module.exports = Vars;
